org.apache.hc.client5.http.classic.methods

## Class HttpOptions

- java.lang.Object
- - org.apache.hc.core5.http.message.HeaderGroup
  - - org.apache.hc.core5.http.message.BasicHttpRequest
    - - org.apache.hc.core5.http.message.BasicClassicHttpRequest
      - - org.apache.hc.client5.http.classic.methods.HttpUriRequestBase
        - - org.apache.hc.client5.http.classic.methods.HttpOptions

- All Implemented Interfaces:
    Serializable, HttpUriRequest, Configurable, org.apache.hc.core5.concurrent.Cancellable, org.apache.hc.core5.concurrent.CancellableDependency, org.apache.hc.core5.http.ClassicHttpRequest, org.apache.hc.core5.http.HttpEntityContainer, org.apache.hc.core5.http.HttpMessage, org.apache.hc.core5.http.HttpRequest, org.apache.hc.core5.http.MessageHeaders

      public class HttpOptions
      extends HttpUriRequestBase

  HTTP OPTIONS method.
  Since:
    4.0
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `METHOD_NAME` The method name "OPTIONS".

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HttpOptions(String uri)` Constructs a new instance initialized with the given URI.
    `HttpOptions(URI uri)` Constructs a new instance initialized with the given URI.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Set<String>` | `getAllowedMethods(org.apache.hc.core5.http.HttpResponse response)` Gets the allowed method names defined by `"Allow"` headers.
    `String` | `getMethod()`

    - ### Methods inherited from class org.apache.hc.client5.http.classic.methods.HttpUriRequestBase

      `abort, cancel, getConfig, isAborted, isCancelled, reset, setConfig, setDependency, toString`

    - ### Methods inherited from class org.apache.hc.core5.http.message.BasicClassicHttpRequest

      `getEntity, setEntity`

    - ### Methods inherited from class org.apache.hc.core5.http.message.BasicHttpRequest

      `addHeader, getAuthority, getPath, getRequestUri, getScheme, getUri, getVersion, setAbsoluteRequestUri, setAuthority, setHeader, setPath, setScheme, setUri, setVersion`

    - ### Methods inherited from class org.apache.hc.core5.http.message.HeaderGroup

      `addHeader, clear, containsHeader, countHeaders, getCondensedHeader, getFirstHeader, getHeader, getHeaders, getHeaders, getLastHeader, headerIterator, headerIterator, removeHeader, removeHeaders, removeHeaders, setHeader, setHeaders`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.hc.core5.http.HttpRequest

      `getAuthority, getPath, getRequestUri, getScheme, getUri, setAuthority, setPath, setScheme, setUri`

    - ### Methods inherited from interface org.apache.hc.core5.http.HttpMessage

      `addHeader, addHeader, getVersion, removeHeader, removeHeaders, setHeader, setHeader, setHeaders, setVersion`

    - ### Methods inherited from interface org.apache.hc.core5.http.MessageHeaders

      `containsHeader, countHeaders, getFirstHeader, getHeader, getHeaders, getHeaders, getLastHeader, headerIterator, headerIterator`

    - ### Methods inherited from interface org.apache.hc.core5.http.HttpEntityContainer

      `getEntity, setEntity`

- - ### Field Detail

    - #### METHOD_NAME

          public static final String METHOD_NAME

      The method name "OPTIONS".
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### HttpOptions

          public HttpOptions(URI uri)

      Constructs a new instance initialized with the given URI.
      Parameters:
        `uri` - a non-null request URI.
      Throws:
        `IllegalArgumentException` - if the uri is null.

    - #### HttpOptions

          public HttpOptions(String uri)

      Constructs a new instance initialized with the given URI.
      Parameters:
        `uri` - a non-null request URI.
      Throws:
        `IllegalArgumentException` - if the uri is invalid.

  - ### Method Detail

    - #### getMethod

          public String getMethod()

      Specified by:
        `getMethod` in interface `org.apache.hc.core5.http.HttpRequest`
      Overrides:
        `getMethod` in class `org.apache.hc.core5.http.message.BasicHttpRequest`

    - #### getAllowedMethods

          public Set<String> getAllowedMethods(org.apache.hc.core5.http.HttpResponse response)

      Gets the allowed method names defined by `"Allow"` headers.
      Parameters:
        `response` - the response to query.
      Returns:
        The response to query.

Copyright © 1999–2021 The Apache Software Foundation. All rights reserved.